package me.unurled.raxen.config;

import static me.unurled.raxen.utils.Utils.debug;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.nio.channels.Channels;
import java.nio.channels.FileChannel;
import java.nio.channels.ReadableByteChannel;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

public class Config {

    private Raxen main;

    private File configFile;

    @Getter
    private FileConfiguration config;

    public Config(Raxen main) {
        this.main = main;
        this.config = main.getConfig();
        this.init();
    }

    /**
     * init method, saves config and everything
     */
    public void init() {
        FileConfiguration config = main.getConfig();
        File configFile = new File(main.getDataFolder() + "/config.yml");
        if (!(configFile.exists())) {
            main.saveDefaultConfig();
        }
        FileConfiguration conf = new YamlConfiguration();
        debug(main, config.getString("version"));
        try {
            conf.load(configFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        debug(main, conf.getString("version"));
        if (!Raxen.getVersion().equals(config.getString("version"))) {
            main.saveResource("config.yml", true);
        }
        if (new File(main.getDataFolder().toString() + "/schematics/").mkdir()) {
            String url = "https://pb.unurled.me/file/otter-panda-cobra/template_tuto.schem";
            ReadableByteChannel readableByteChannel = null;
            try {
                readableByteChannel = Channels.newChannel(new URL(url).openStream());
                FileOutputStream fileOutputStream = new FileOutputStream(
                    main.getDataFolder() + "schematics/template_tuto.schem");
                FileChannel fileChannel = fileOutputStream.getChannel();
                fileOutputStream.getChannel()
                    .transferFrom(readableByteChannel, 0, Long.MAX_VALUE);
            } catch (IOException e) {
//                throw new RuntimeException(e);
            }

//            main.saveResource("schematics/template_tuto.schem", false);
        }
        ;
    }
}
